package jp.agentec.abook.abv.bl.data.tables;

import java.util.ArrayList;
import java.util.List;

import jp.agentec.abook.abv.bl.common.db.SQLiteDatabase;
import jp.agentec.abook.abv.bl.data.DatabaseVersions;

public class MShopMember extends SQLiteTableScript {

    public MShopMember() {
    };

    @Override
    public List<String> getCreateScript(int version) {
        List<String> ddl = new ArrayList<String>();
        StringBuffer sql = new StringBuffer();

        sql.append(" create table m_shop_member ( ");
        sql.append("        shop_member_id INTEGER NOT NULL ");
        sql.append("      , shop_member_name VARCHAR(64) ");
        sql.append("      , login_id VARCHAR(64) ");
        sql.append("      , profile_url VARCHAR(64) ");
        sql.append("      , favorite_register_date VARCHAR2(64) ");
        sql.append("      , self_flg INTEGER NOT NULL ");
        sql.append("      , PRIMARY KEY (shop_member_id) ");
        sql.append(" ) ");

        ddl.add(sql.toString());

        return ddl;
    }

    @Override
    public List<String> getUpgradeScript(int oldVersion, int newVersion) {
        List<String> ddl = new ArrayList<String>();
        if (oldVersion < DatabaseVersions.Ver1_3_000) {
            ddl.addAll(getCreateScript(newVersion));
        }
        return ddl;
    }

    @Override
    public List<String> getMigrationScript(SQLiteDatabase databaseConnection, int oldVersion, int newVersion, Object... params) {
        return null;
    }
}
