package jp.agentec.abook.abv.bl.data.tables;

import java.util.ArrayList;
import java.util.List;

import jp.agentec.abook.abv.bl.common.db.SQLiteDatabase;
import jp.agentec.abook.abv.bl.data.DatabaseVersions;

/**
 * Created by leej on 2018/08/31.
 */

public class TTaskReport extends SQLiteTableScript {

    public TTaskReport() {
        super();
    }

    @Override
    public List<String> getCreateScript(int version) {
        List<String> ddl = new ArrayList<String>();
        StringBuffer sql = new StringBuffer();

        sql.append(" CREATE TABLE t_task_report ( ");
        sql.append("        task_key TEXT NOT NULL ");
        sql.append("      , json_data TEXT NOT NULL");
        sql.append("      , attached_file_name TEXT ");
        sql.append("      , local_attached_file_name TEXT ");
        sql.append("      , attached_file_send_flg BOOLEAN DEFAULT 0 ");
        sql.append("      , data_send_flg BOOLEAN DEFAULT 0 ");
        sql.append("      , report_start_date DATETIME ");
        sql.append("      , report_end_date DATETIME ");
        sql.append("      , task_report_id INTEGER NOT NULL DEFAULT 0 ");
        sql.append("      , task_report_info_id INTEGER NOT NULL DEFAULT 0 ");
        sql.append("      , enable_report SMALLINT NOT NULL DEFAULT 0 ");
        sql.append("      , task_report_level SMALLINT NOT NULL DEFAULT 0 ");
        sql.append("      , local_saved_flg BOOLEAN DEFAULT 0 ");
        sql.append(" ) ");
        ddl.add(sql.toString());

        return ddl;
    }


    @Override
    public List<String> getUpgradeScript(int oldVersion, int newVersion) {
        return null;
    }

    @Override
    public List<String> getMigrationScript(SQLiteDatabase databaseConnection, int oldVersion, int newVersion, Object[] params) {
        return null;
    }
}
